unit Wzda;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, DB, StdCtrls, Buttons, Grids, DBGrids,
  ExtCtrls, DBCtrls, Printp;

type
  TFrmWZDA = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Query1: TQuery;
    DataSource2: TDataSource;
    Query1ClBh: TStringField;
    Query1Clmc: TStringField;
    Query1Gg: TStringField;
    Query1Dw: TStringField;
    DBNavigator1: TDBNavigator;
    Query1ID: TStringField;
    Query1LbID: TStringField;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    DBGrid1: TDBGrid;
    Query1Cd: TStringField;
    Preview1: TPreview;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Query1NewRecord(DataSet: TDataset);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmWZDA: TFrmWZDA;

implementation

var
  lb:string;

{$R *.DFM}

procedure TFrmWZDA.FormActivate(Sender: TObject);
begin
  ComboBox1.Items.Clear;
  ComboBox1.Items.Add('Ʒ');
  Table1.Open;
  while not Table1.Eof do
  begin
    ComboBox1.Items.Add(Table1.FieldByName('NAME').asString);
    Table1.Next;
  end;
  Table1.Close;
  ComboBox1.ItemIndex:=0;
  ComboBox1Change(self);
end;

procedure TFrmWZDA.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.ItemIndex=0 then
  begin
    with Query1 do
    begin
      Close;
      SQL.Clear;
      SQL.Add('select id,lbid,clbh,clmc,gg,dw,cd,jhdj from clbm');
      Prepare;
      ExecSQL;
      Open;
      First;
    end;
  end
  else
  begin
    with Table1 do
    begin
      Open;
      MoveBy(ComboBox1.ItemIndex-1);
      lb:=FieldByName('LBID').asString;
      Close;
    end;
    with Query1 do
    begin
      Close;
      SQL.Clear;
      SQL.Add('select id,lbid,clbh,clmc,gg,dw,cd,jhdj from clbm where lbid=:lb');
      Prepare;
      Params[0].asString:=lb;
      ExecSQL;
      Open;
      First;
    end;
  end;
end;

procedure TFrmWZDA.BitBtn2Click(Sender: TObject);
begin
  Query1.Edit;
  Query1.Post;
  Query1.Close;
  Close;
end;

procedure TFrmWZDA.BitBtn1Click(Sender: TObject);
begin
  Preview1.PrnEmpty:=True;
  Preview1.Titletitle:='Ʒ%RIGHT%%GETDATE%';
  Preview1.PrintReport;
  Preview1.PrnEmpty:=False;
end;

procedure TFrmWZDA.BitBtn3Click(Sender: TObject);
begin
  Preview1.PrintReport;
end;

procedure TFrmWZDA.Query1NewRecord(DataSet: TDataset);
begin
  Query1.FieldByName('LBID').asString:=lb;
  Query1.FieldByName('CLMC').asString:=ComboBox1.Text;
  Query1.FieldByName('ID').asString:=lb;
end;

procedure TFrmWZDA.FormCreate(Sender: TObject);
begin
  Table1.DatabaseName:=ExtractFilePath(Application.ExeName);
  Query1.DatabaseName:=ExtractFilePath(Application.ExeName);
end;

end.
