unit Xsgl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, DBCtrls, Grids, DBGrids, Mask,
  DBLookup, Printp, ExtCtrls, DBTables, DB;

type
  TFrmxsd = class(TForm)
    DataSource3: TDataSource;
    Tbm: TTable;
    DataSource1: TDataSource;
    Txsd: TTable;
    Tck: TTable;
    DataSource4: TDataSource;
    DataSource5: TDataSource;
    Tryid: TTable;
    Tclbm: TTable;
    DataSource2: TDataSource;
    Query1: TQuery;
    Query1cclbh: TStringField;
    Query1Cclmc: TStringField;
    Query1Cgg: TStringField;
    Query1Cdw: TStringField;
    Query1Fcsl: TFloatField;
    Query1Fcdj: TFloatField;
    Query1Cje: TStringField;
    Query1ClID: TStringField;
    Query1Rq: TDateField;
    Query1Ckid: TStringField;
    Query1Zy: TStringField;
    Query1Dh: TSmallintField;
    Panel1: TPanel;
    Label1: TLabel;
    ArtShape2: TArtShape;
    ArtShape1: TArtShape;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    Label5: TLabel;
    DBLookupCombo2: TDBLookupCombo;
    Label7: TLabel;
    DBLookupCombo3: TDBLookupCombo;
    Label6: TLabel;
    Label4: TLabel;
    DBEdit2: TDBEdit;
    DBLookupCombo4: TDBLookupCombo;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Query1Djlx: TSmallintField;
    Label2: TLabel;
    TxsdLldID: TSmallintField;
    TxsdLldh: TStringField;
    TxsdRq: TDateField;
    TxsdCkid: TStringField;
    TxsdYwy: TSmallintField;
    TxsdSkr: TSmallintField;
    TxsdKpr: TSmallintField;
    TxsdThr: TStringField;
    TxsdCgy: TSmallintField;
    DBEdit3: TDBEdit;
    Label8: TLabel;
    Label9: TLabel;
    DBLookupCombo1: TDBLookupCombo;
    DBLookupCombo5: TDBLookupCombo;
    ArtShape3: TArtShape;
    Label10: TLabel;
    ArtShape5: TArtShape;
    Label11: TLabel;
    ArtShape6: TArtShape;
    Label12: TLabel;
    Preview1: TPreview;
    procedure FormShow(Sender: TObject);
    procedure TxsdAfterInsert(DataSet: TDataset);
    procedure TxsdBeforeInsert(DataSet: TDataset);
    procedure TxsdBeforeDelete(DataSet: TDataset);
    procedure Query1AfterInsert(DataSet: TDataset);
    procedure Query1CalcFields(DataSet: TDataset);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Query1BeforeInsert(DataSet: TDataset);
    procedure Query1AfterPost(DataSet: TDataset);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Frmxsd: TFrmxsd;

implementation
uses
  csupper;
var
  LldID:integer;
  flag:Boolean;
{$R *.DFM}

procedure TFrmxsd.FormShow(Sender: TObject);
begin
  Tclbm.Open;
  Tbm.Open;
  Tryid.open;
  Tck.open;
  Txsd.Open;
  Txsd.Last;
  Query1.Open;
  Query1AfterPost(Query1);
end;

procedure TFrmxsd.TxsdAfterInsert(DataSet: TDataset);
begin
  Query1.Close;
  Txsd.FieldByName('LLDID').asInteger:=LldID;
  Txsd.FieldByName('RQ').asDateTime:=Date;
  Query1.Open;
end;

procedure TFrmxsd.TxsdBeforeInsert(DataSet: TDataset);
begin
  with Txsd do
  begin
    if RecordCount=0 then
       LldID:=1
    else
    begin
      last;
      LldID:=FieldByName('LLDID').asInteger+1;
    end;
  end;
end;

procedure TFrmxsd.TxsdBeforeDelete(DataSet: TDataset);
begin
  with Query1 do
  begin
    First;
    while not Eof do
    begin
      Delete;
      next;
    end;
  end;
end;

procedure TFrmxsd.Query1AfterInsert(DataSet: TDataset);
begin
  if flag then Exit;
   with query1 do
   begin
      Edit;
      FieldByName('dh').asInteger:=Txsd.FieldByName('LLDID').asInteger;
      fieldbyname('djlx').asinteger := 2;
      FieldByName('rq').asdatetime:=txsd.FieldByName('rq').asdatetime;
      fieldbyname('ckid').asstring := txsd.fieldbyname('ckid').asstring;
   end;
end;

procedure TFrmxsd.Query1CalcFields(DataSet: TDataset);
var
  TClid:string;
begin
  with Query1 do
  begin
    TClid:=FieldByName('CLID').asString;
    if Tclbm.FindKey([TClid]) then
    begin
      FieldByName('CCLBH').asString:=Tclbm.FieldByName('CLBH').asString;
      FieldByName('CCLMC').asString:=Tclbm.FieldByName('CLMC').asString;
      FieldByName('CGG').asString:=Tclbm.FieldByName('GG').asString;
      FieldByName('CDW').asString:=Tclbm.FieldByName('DW').asString;
      fieldbyname('cje').asfloat := fieldbyname('fcsl').asfloat*fieldbyname('fcdj').asfloat;
    end;
  end;
end;

procedure TFrmxsd.BitBtn2Click(Sender: TObject);
begin
  Preview1.FitPageWidth:=False;
  Preview1.FitPageHeight:=False;
  Preview1.RecNumPerPage:=8;
  Preview1.PrintReport;
end;

procedure TFrmxsd.BitBtn1Click(Sender: TObject);
begin
  if (Txsd.State=dsEdit) or (Txsd.State=dsInsert) then txsd.post;
  if (Query1.State=dsEdit) or (Query1.State=dsInsert) then query1.post;
  Tbm.Close;
  Txsd.Close;
  Query1.Close;
  Tclbm.Close;
  Tryid.close;
  Tck.close;
  close;
end;

procedure TFrmxsd.Query1BeforeInsert(DataSet: TDataset);
var
  Count:integer;
begin
  flag:=False;
  Count:=0;
  with DataSet do
  begin
    First;
    while not Eof do
    begin
      Count:=Count+1;
      Next;
    end;
    if Count>7 then
    begin
      Application.MessageBox('۵¼ܳ8','ʾ',mb_ok);
      Cancel;
      flag:=True;
    end;
  end;
end;

procedure TFrmxsd.Query1AfterPost(DataSet: TDataset);
var
  je:real;
begin
  with Query1 do
  begin
    First;
    je:=0.0;
    while not Eof do
    begin
      je:=je+FieldByName('cje').asFloat;
      Next;
    end;
    Label12.Caption:=NumToUpper(je);
    Label11.Caption:=Format('%8.2f',[je]);
  end;
end;

procedure TFrmxsd.FormCreate(Sender: TObject);
var
  temp:string;
begin
  temp:=ExtractFilePath(Application.ExeName);
  Tclbm.DatabaseName:=temp;
  Tbm.DatabaseName:=temp;
  Tryid.DatabaseName:=temp;
  Tck.DatabaseName:=temp;
  Txsd.DatabaseName:=temp;
  Query1.DatabaseName:=temp;
end;

end.
