unit Rskp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, DB, DBTables, StdCtrls, Mask,
  DBCtrls, Printp;

type
  TfrmRskp = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    tbBM: TTable;
    dsBM: TDataSource;
    pnPrt: TPanel;
    Label1: TLabel;
    cbBM: TComboBox;
    qeRSDA: TQuery;
    qeRSDAXM: TStringField;
    qeRSDABH: TStringField;
    qeRSDAMC: TStringField;
    qeRSDAXB: TStringField;
    qeRSDACSNY: TStringField;
    qeRSDAWH: TStringField;
    qeRSDAGZSJ: TStringField;
    qeRSDADTY: TStringField;
    qeRSDAZW: TStringField;
    qeRSDAZC: TStringField;
    qeRSDAXRGZ: TStringField;
    qeRSDAGZ: TFloatField;
    qeRSDAJG: TStringField;
    qeRSDAJJZZ: TStringField;
    qeRSDADH: TStringField;
    qeRSDAZP: TBlobField;
    dsRSDA: TDataSource;
    Label2: TLabel;
    EditXM: TDBEdit;
    Label3: TLabel;
    Editxb: TDBEdit;
    Label4: TLabel;
    DBEdit2: TDBEdit;
    Label46: TLabel;
    DBEdit43: TDBEdit;
    Label8: TLabel;
    DBEdit5: TDBEdit;
    Label14: TLabel;
    DBEdit11: TDBEdit;
    Label11: TLabel;
    DBEdit8: TDBEdit;
    Label13: TLabel;
    DBEdit10: TDBEdit;
    Label5: TLabel;
    DBEdit1: TDBEdit;
    Label7: TLabel;
    DBEdit4: TDBEdit;
    Label6: TLabel;
    DBEdit3: TDBEdit;
    Label16: TLabel;
    DBEdit12: TDBEdit;
    Label9: TLabel;
    DBEdit6: TDBEdit;
    Label12: TLabel;
    DBEdit9: TDBEdit;
    Label15: TLabel;
    EditBH: TDBEdit;
    qeRSDABm: TStringField;
    DBNavigator1: TDBNavigator;
    DBImage1: TDBImage;
    Label18: TLabel;
    DBMemo1: TDBMemo;
    qeRSDAJL: TMemoField;
    Label10: TLabel;
    ryCound: TLabel;
    ArtShape1: TArtShape;
    ArtShape2: TArtShape;
    ArtShape3: TArtShape;
    ArtShape4: TArtShape;
    ArtShape5: TArtShape;
    ArtShape6: TArtShape;
    ArtShape7: TArtShape;
    ArtShape8: TArtShape;
    ArtShape9: TArtShape;
    ArtShape10: TArtShape;
    ArtShape11: TArtShape;
    ArtShape12: TArtShape;
    ArtShape13: TArtShape;
    ArtShape14: TArtShape;
    ArtShape15: TArtShape;
    ArtShape16: TArtShape;
    ArtShape17: TArtShape;
    ArtShape18: TArtShape;
    ArtShape19: TArtShape;
    ArtShape20: TArtShape;
    Label19: TLabel;
    funModal: TButton;
    Preview1: TPreview;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbBMChange(Sender: TObject);
    procedure qeRSDAAfterOpen(DataSet: TDataset);
    procedure qeRSDABeforePost(DataSet: TDataset);
    procedure funModalClick(Sender: TObject);
    procedure DBImage1DblClick(Sender: TObject);
  private
    { Private declarations }
    bmDM,bmName:String;
    RSDACount:Integer;
    procedure getBmDM;
    procedure getBM;
  public
    { Public declarations }
  end;

var
  frmRskp: TfrmRskp;

implementation
{$R *.DFM}

procedure TfrmRskp.getBmDM;
begin
  bmName:=cbBM.Text;
  bmDM:='%';
  with tbBM do
    begin
      open;
      while not Eof do
        begin
          if FieldByName('Mc').AsString=bmName then
            begin
              bmDM:=FieldByName('Dm').AsString;
              Close;
              exit;
            end;
          Next;
        end;
      Close
    end;
end;

procedure TfrmRskp.getBM;
begin
  bmDM:='%';
  bmName:='в';
  with tbBM do
    begin
      cbBM.Items.Clear;
      cbBM.Items.Add(bmName);
      Open;
      while not Eof do
        begin
          cbBM.Items.Add(FieldByName('Mc').AsString);
          Next;
        end;
      Close
    end;
  cbBM.Text:=bmName;
end;

procedure TfrmRskp.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmRskp.FormCreate(Sender: TObject);
begin
  tbBm.DatabaseName:=ExtractFilePath(Application.ExeName);
  qeRSDA.DatabaseName:=ExtractFilePath(Application.ExeName);
  tbBm.Open;
  qeRSDA.Open;
  getBM;
end;

procedure TfrmRskp.cbBMChange(Sender: TObject);
begin
  getBmDM;
  with qeRSDA do
    begin
      Close;
      Params[0].AsString:=bmDM;
      Open;
    end;
end;

procedure TfrmRskp.qeRSDAAfterOpen(DataSet: TDataset);
begin
  RSDACount:=0;
  with qeRSDA do
    begin
      DisableControls;
      While not Eof do
        begin
          Inc(RSDACount);
          Next;
        end;
      First;
      EnableControls;
    end;
  ryCound.Caption:=IntToStr(RSDACount);
end;

procedure TfrmRskp.qeRSDABeforePost(DataSet: TDataset);
begin
  with qeRSDA do
    begin
      FieldByName('Bm').AsString:=bmDM;
    end;
end;

procedure TfrmRskp.funModalClick(Sender: TObject);
begin
  Preview1.FitPageHeight:=False;
  Preview1.PrinterView(1,0);
end;

procedure TfrmRskp.DBImage1DblClick(Sender: TObject);
begin
  DBImage1.LoadPicture;
end;

end.
